Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/ice.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/ice.F90	(revision 11876)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/ice.F90	(revision 11877)
@@ -225,4 +225,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   divu_i      !: Divergence of the velocity field             [s-1]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   shear_i     !: Shear of the velocity field                  [s-1]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   aniso_11, aniso_12   !: structure tensor elements
    !
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   t_bo        !: Sea-Ice bottom temperature [Kelvin]     
@@ -407,5 +408,6 @@
       ALLOCATE( u_oce    (jpi,jpj) , v_oce    (jpi,jpj) , ht_i_new  (jpi,jpj) , strength(jpi,jpj) ,  &
          &      stress1_i(jpi,jpj) , stress2_i(jpi,jpj) , stress12_i(jpi,jpj) ,                      &
-         &      delta_i  (jpi,jpj) , divu_i   (jpi,jpj) , shear_i   (jpi,jpj) , STAT=ierr(ii) )
+         &      delta_i  (jpi,jpj) , divu_i   (jpi,jpj) , shear_i   (jpi,jpj) ,                      &
+         &      aniso_11 (jpi,jpj) , aniso_12 (jpi,jpj) , STAT=ierr(ii) )
 
       ii = ii + 1
Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg.F90	(revision 11876)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg.F90	(revision 11877)
@@ -86,5 +86,5 @@
       CASE( np_rhgEAP )                ! Elasto-Anisotropic-Plastic !
          !                             !----------------------------!
-         CALL ice_dyn_rhg_eap( kt, stress1_i, stress2_i, stress12_i, shear_i, divu_i, delta_i )
+         CALL ice_dyn_rhg_eap( kt, stress1_i, stress2_i, stress12_i, shear_i, divu_i, delta_i, aniso_11, aniso_12 )
       END SELECT
       !
Index: /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg_eap.F90
===================================================================
--- /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg_eap.F90	(revision 11876)
+++ /NEMO/branches/2019/dev_r11842_SI3-10_EAP/src/ICE/icedyn_rhg_eap.F90	(revision 11877)
@@ -56,5 +56,5 @@
 CONTAINS
 
-   SUBROUTINE ice_dyn_rhg_eap( kt, pstress1_i, pstress2_i, pstress12_i, pshear_i, pdivu_i, pdelta_i )
+   SUBROUTINE ice_dyn_rhg_eap( kt, pstress1_i, pstress2_i, pstress12_i, pshear_i, pdivu_i, pdelta_i, aniso_11, aniso_12 )
       !!-------------------------------------------------------------------
       !!                 ***  SUBROUTINE ice_dyn_rhg_eap  ***
@@ -111,4 +111,5 @@
       REAL(wp), DIMENSION(:,:), INTENT(inout) ::   pstress1_i, pstress2_i, pstress12_i   !
       REAL(wp), DIMENSION(:,:), INTENT(  out) ::   pshear_i  , pdivu_i   , pdelta_i      !
+      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   aniso_11, aniso_12   ! structure tensor components
       !!
       INTEGER ::   ji, jj       ! dummy loop indices
@@ -867,5 +868,5 @@
       !
       INTEGER  ::   iter            ! local integer
-      INTEGER  ::   id1, id2, id3   ! local integers
+      INTEGER  ::   id1, id2, id3, id4, id5   ! local integers
       !!----------------------------------------------------------------------
       !
@@ -877,9 +878,13 @@
             id2 = iom_varid( numrir, 'stress2_i' , ldstop = .FALSE. )
             id3 = iom_varid( numrir, 'stress12_i', ldstop = .FALSE. )
-            !
-            IF( MIN( id1, id2, id3 ) > 0 ) THEN      ! fields exist
+            id4 = iom_varid( numrir, 'aniso_11' , ldstop = .FALSE. )
+            id5 = iom_varid( numrir, 'aniso_12' , ldstop = .FALSE. )
+            !
+            IF( MIN( id1, id2, id3, id4, id5 ) > 0 ) THEN      ! fields exist
                CALL iom_get( numrir, jpdom_autoglo, 'stress1_i' , stress1_i  )
                CALL iom_get( numrir, jpdom_autoglo, 'stress2_i' , stress2_i  )
                CALL iom_get( numrir, jpdom_autoglo, 'stress12_i', stress12_i )
+               CALL iom_get( numrir, jpdom_autoglo, 'aniso_11' , aniso_11 )
+               CALL iom_get( numrir, jpdom_autoglo, 'aniso_12' , aniso_12 )
             ELSE                                     ! start rheology from rest
                IF(lwp) WRITE(numout,*)
@@ -888,4 +893,6 @@
                stress2_i (:,:) = 0._wp
                stress12_i(:,:) = 0._wp
+               aniso_11 (:,:) = 0.5_wp
+               aniso_12 (:,:) = 0._wp
             ENDIF
          ELSE                                   !* Start from rest
@@ -895,4 +902,6 @@
             stress2_i (:,:) = 0._wp
             stress12_i(:,:) = 0._wp
+            aniso_11 (:,:) = 0.5_wp
+            aniso_12 (:,:) = 0._wp
          ENDIF
          !
@@ -905,4 +914,6 @@
          CALL iom_rstput( iter, nitrst, numriw, 'stress2_i' , stress2_i  )
          CALL iom_rstput( iter, nitrst, numriw, 'stress12_i', stress12_i )
+         CALL iom_rstput( iter, nitrst, numriw, 'aniso_11' , aniso_11 )
+         CALL iom_rstput( iter, nitrst, numriw, 'aniso_12' , aniso_12 )
          !
       ENDIF