Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg	(revision 11871)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_coare3p6_cfg	(revision 11892)
@@ -20,5 +20,6 @@
 &namusr_def    !   STATION_ASF user defined namelist
 !-----------------------------------------------------------------------
-   rn_dept1    =  1.0   ! depth (m) at which the prescribed SST is taken == depth of first T point! (IMPORTANT for warm-layer impact, the deeper, the more pronounced!)
+   rn_dept1    =  1.0   ! depth (m) at which the prescribed SST is taken  == depth of first T point! (IMPORTANT for warm-layer impact, the deeper, the more pronounced!)
+   !                    ! [PAPA station = 1 m]
 /
 !-----------------------------------------------------------------------
@@ -68,7 +69,6 @@
 &namc1d        !   1D configuration options / STATION_ASF               ("key_c1d" default: PAPA station)
 !-----------------------------------------------------------------------
-   rn_lat1d    =      50.1 !  Column latitude
-   rn_lon1d    =    215.1  !  Column longitude
-   ln_c1d_locpt =  .true.  ! Localization of 1D config in a grid (T) or independant point (F)
+   rn_lat1d    =      50.1 !  Column latitude    [PAPA station]
+   rn_lon1d    =    215.1  !  Column longitude   [PAPA station]
 /
 !-----------------------------------------------------------------------
@@ -124,6 +124,6 @@
    ln_COARE_3p6 = .true.    ! "COARE 3.5" algorithm   (Edson et al. 2013)
    ln_ECMWF     = .false.   ! "ECMWF"     algorithm   (IFS cycle 31)
-      rn_zqt      =  2.     !  Air temperature & humidity reference height (m)
-      rn_zu       = 10.     !  Wind vector reference height (m)
+      rn_zqt    =  2.5      !  Air temperature & humidity reference height (m) [PAPA station]
+      rn_zu     =  4.       !  Wind vector reference height (m)                [PAPA station]
       !
       ! Skin is ONLY available in ECMWF and COARE algorithms:
Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg	(revision 11871)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_ecmwf_cfg	(revision 11892)
@@ -20,5 +20,6 @@
 &namusr_def    !   STATION_ASF user defined namelist
 !-----------------------------------------------------------------------
-   rn_dept1    =  1.0   ! depth (m) at which the prescribed SST is taken == depth of first T point! (IMPORTANT for warm-layer impact, the deeper, the more pronounced!)
+   rn_dept1    =  1.0   ! depth (m) at which the prescribed SST is taken  == depth of first T point! (IMPORTANT for warm-layer impact, the deeper, the more pronounced!)
+   !                    ! [PAPA station = 1 m]
 /
 !-----------------------------------------------------------------------
@@ -68,7 +69,6 @@
 &namc1d        !   1D configuration options / STATION_ASF               ("key_c1d" default: PAPA station)
 !-----------------------------------------------------------------------
-   rn_lat1d    =      50.1 !  Column latitude
-   rn_lon1d    =    215.1  !  Column longitude
-   ln_c1d_locpt =  .true.  ! Localization of 1D config in a grid (T) or independant point (F)
+   rn_lat1d    =      50.1 !  Column latitude    [PAPA station]
+   rn_lon1d    =    215.1  !  Column longitude   [PAPA station]
 /
 !-----------------------------------------------------------------------
@@ -124,6 +124,6 @@
    ln_COARE_3p6 = .false.   ! "COARE 3.5" algorithm   (Edson et al. 2013)
    ln_ECMWF     = .true.    ! "ECMWF"     algorithm   (IFS cycle 31)
-      rn_zqt      =  2.     !  Air temperature & humidity reference height (m)
-      rn_zu       = 10.     !  Wind vector reference height (m)
+      rn_zqt    =  2.5      !  Air temperature & humidity reference height (m) [PAPA station]
+      rn_zu     =  4.       !  Wind vector reference height (m)                [PAPA station]
       !
       ! Skin is ONLY available in ECMWF and COARE algorithms:
Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_ncar_cfg
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_ncar_cfg	(revision 11871)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/EXPREF/namelist_ncar_cfg	(revision 11892)
@@ -20,5 +20,6 @@
 &namusr_def    !   STATION_ASF user defined namelist
 !-----------------------------------------------------------------------
-   rn_dept1    =  1.0   ! depth (m) at which the prescribed SST is taken == depth of first T point! (IMPORTANT for warm-layer impact, the deeper, the more pronounced!)
+   rn_dept1    =  1.0   ! depth (m) at which the prescribed SST is taken  == depth of first T point! (IMPORTANT for warm-layer impact, the deeper, the more pronounced!)
+   !                    ! [PAPA station = 1 m]
 /
 !-----------------------------------------------------------------------
@@ -68,7 +69,6 @@
 &namc1d        !   1D configuration options / STATION_ASF               ("key_c1d" default: PAPA station)
 !-----------------------------------------------------------------------
-   rn_lat1d    =      50.1 !  Column latitude
-   rn_lon1d    =    215.1  !  Column longitude
-   ln_c1d_locpt =  .true.  ! Localization of 1D config in a grid (T) or independant point (F)
+   rn_lat1d    =      50.1 !  Column latitude    [PAPA station]
+   rn_lon1d    =    215.1  !  Column longitude   [PAPA station]
 /
 !-----------------------------------------------------------------------
@@ -124,6 +124,6 @@
    ln_COARE_3p6 = .false.   ! "COARE 3.5" algorithm   (Edson et al. 2013)
    ln_ECMWF     = .false.   ! "ECMWF"     algorithm   (IFS cycle 31)
-      rn_zqt      =  2.     !  Air temperature & humidity reference height (m)
-      rn_zu       = 10.     !  Wind vector reference height (m)
+      rn_zqt    =  2.5      !  Air temperature & humidity reference height (m) [PAPA station]
+      rn_zu     =  4.       !  Wind vector reference height (m)                [PAPA station]
       !
       ! Skin is ONLY available in ECMWF and COARE algorithms:
Index: NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/README.md
===================================================================
--- NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/README.md	(revision 11871)
+++ NEMO/branches/2019/dev_r11085_ASINTER-05_Brodeau_Advanced_Bulk/tests/STATION_ASF/README.md	(revision 11892)
@@ -8,11 +8,11 @@
 ```STATION_ASF``` is a demonstration case that mimics an in-situ station (buoy, platform) dedicated to the estimation of surface air-sea fluxes by means of the measurement of traditional meteorological surface parameters.
 
-```STATION_ASF``` is based on the merging of the "single column" and the "standalone surface module" configurations of NEMO (C1D meets SAS). As such, the spatial domain of ```STATION_ASF``` is punctual (1D).
+```STATION_ASF``` is based on the merging of the "single column" and the "standalone surface module" configurations of NEMO. In short, it coulb defined as "SAS meets C1D". As such, the spatial domain of ```STATION_ASF``` is punctual (1D, well actually 3 x 3 as in C1D).
 
-```STATION_ASF``` is therefore a very light and versatile tool to test the different bulk algorithms and cool-skin/warm-layer parameterizations included in NEMO.
+```STATION_ASF``` is therefore a versatile tool, and extremely light in terms of computing requirements, to test the different bulk algorithms and cool-skin/warm-layer parameterization options included in NEMO.
 
-As input ```STATION_ASF``` will require the sea surface parameters:
+As input ```STATION_ASF``` will require the traditional *bulk* sea surface parameters:
 
-- bulk sea surface temperature (SST) at $z_{SST}$ meters below the surface
+- sea surface temperature (SST) at $z_{SST}$ meters below the surface
 - Surface current vector
 - Sea surface salinity
@@ -31,6 +31,4 @@
 ## Physical description
 
-
-
 ### Important namelist parameters speficic to STATION_ASF
 
@@ -47,8 +45,8 @@
 ## Input files to test STATION ASF
 
-Three full years of hourly data from the PAPA buoy can be downloaded here:
+Three full years of processed hourly data from the PAPA station (buoy) can be downloaded here:
 https://drive.google.com/file/d/1MxNvjhRHmMrL54y6RX7WIaM9-LGl--ZP/
 
-These two files are everything you need to play with the set of namelists provided for this test-case.
+These three files are everything you need to play with the set of namelists provided for this test-case.
 
 - ```Station_PAPA_50N-145W_atm_hourly.nc```  → contains hourly surface atmospheric state
@@ -56,2 +54,18 @@
 - ```Station_PAPA_50N-145W_oce_hourly.nc``` → contains hourly sea surface state
 
+For station PAPA (50.1 N, 144.9 W), air temperature and humidity are measured at 2.5 m, the wind speed at 4 m, and the SST at 1 m below the surface, hence the following namelist parameters are given:
+
+- ```rn_dept1 =    1.  ``` (&namusr_def)
+- ```rn_lat1d =  50.1 ``` (&namc1d)
+- ```rn_lon1d = 215.1``` (&namc1d)
+- ```rn_zqt   =   2.5``` (&namsbc_blk)
+- ```rn_zu    =    4.``` (&namsbc_blk)
+
+
+
+
+
+
+
+
+