Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/tests/ISOMIP+/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/tests/ISOMIP+/EXPREF/namelist_cfg	(revision 11895)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/tests/ISOMIP+/EXPREF/namelist_cfg	(revision 11896)
@@ -62,6 +62,9 @@
    !           !  file name              ! frequency (hours) ! variable  ! time interp.!  clim  ! 'yearly'/ ! weights filename ! rotation ! land/sea mask !
    !           !                         !  (if <0  months)  !   name    !   (logical) !  (T/F) ! 'monthly' !                  ! pairing  !    filename   !
-   sn_tem = 'TS_init',  -12.    , 'Tinit',   .true.    , .true. , 'yearly'  ,    ''            ,    ''    ,    ''
-   sn_sal = 'TS_init',  -12.    , 'Sinit',   .true.    , .true. , 'yearly'  ,    ''            ,    ''    ,    ''
+   sn_tem  = 'nemo_base_WARM.nc'         ,  -12.    , 'Tinit',   .false.    , .true. , 'yearly'  ,    ''            ,    ''    ,    ''
+   sn_sal  = 'nemo_base_WARM.nc'         ,  -12.    , 'Sinit',   .false.    , .true. , 'yearly'  ,    ''            ,    ''    ,    ''
+
+   sn_dmpt = 'nemo_base_WARM.nc'         ,  -12.    , 'Tinit',   .false.    , .true. , 'yearly'  ,    ''            ,    ''    ,    ''
+   sn_dmps = 'nemo_base_WARM.nc'         ,  -12.    , 'Sinit',   .false.    , .true. , 'yearly'  ,    ''            ,    ''    ,    ''
 /
 !-----------------------------------------------------------------------
@@ -111,4 +114,5 @@
 
    ln_usr      = .true.   !  user defined formulation                  (T => check usrdef_sbc)
+   nn_fwb      = 1
 /
 !-----------------------------------------------------------------------
@@ -181,6 +185,6 @@
          !                       ! ad15 = velocity dependend Gamma (u* * gammat/s)  (Jenkins et al. 2010)
          !                       ! hj99 = velocity and stability dependent Gamma    (Holland et al. 1999)
-         rn_gammat0  = 0.045     ! gammat coefficient used in blk formula
-         rn_gammas0  = 1.29e-3   ! gammas coefficient used in blk formula
+         rn_gammat0  = 0.0215    ! gammat coefficient used in blk formula
+         rn_gammas0  = 0.614e-3  ! gammas coefficient used in blk formula
          rn_vtide    = 0.01      ! tidal velocity [m/s]
          !
@@ -227,5 +231,4 @@
    !                       !  free slip  !   partial slip  !   no slip   ! strong slip
    rn_shlat    =  2.       !  shlat = 0  !  0 < shlat < 2  !  shlat = 2  !  2 < shlat
-   ln_vorlat   = .false.   !  consistency of vorticity boundary condition with analytical Eqs.
 /
 !-----------------------------------------------------------------------
@@ -270,4 +273,5 @@
 !-----------------------------------------------------------------------
    rn_Cd0      =  2.5e-3   !  drag coefficient [-]
+   rn_ke0      =  0.0e-3   !  background kinetic energy  [m2/s2] (non-linear cases)
 /
 !-----------------------------------------------------------------------
@@ -275,4 +279,5 @@
 !-----------------------------------------------------------------------
    rn_Cd0      =  2.5e-3    !  drag coefficient [-]
+   rn_ke0      =  0.0e-3    !  background kinetic energy  [m2/s2] (non-linear cases)
 /
 !-----------------------------------------------------------------------
@@ -300,5 +305,14 @@
 &nameos        !   ocean Equation Of Seawater                           (default: NO selection)
 !-----------------------------------------------------------------------
-   ln_eos80    = .true.          !  = Use EOS80
+   ln_teos10   = .false.         !  = Use TEOS-10
+   ln_eos80    = .false.         !  = Use EOS80
+   ln_leos     = .true.          !  = Use S-EOS (simplified Eq.)
+                                 !
+   !                     ! S-EOS coefficients (ln_seos=T):
+   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   !                     ! L-EOS coefficients (ln_seos=T):
+   !                             !  rd(T,S,Z)*rau0 = rau0*(-a0*dT+b0*dS)
+   rn_a0       =  3.7330e-5      !  thermal expension coefficient
+   rn_b0       =  7.8430e-4      !  saline  expension coefficient
 /
 !-----------------------------------------------------------------------
Index: /NEMO/branches/2019/ENHANCE-02_ISF_nemo/tests/ISOMIP+/MY_SRC/sbcfwb.F90
===================================================================
--- /NEMO/branches/2019/ENHANCE-02_ISF_nemo/tests/ISOMIP+/MY_SRC/sbcfwb.F90	(revision 11895)
+++ /NEMO/branches/2019/ENHANCE-02_ISF_nemo/tests/ISOMIP+/MY_SRC/sbcfwb.F90	(revision 11896)
@@ -105,10 +105,21 @@
          !
          IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
+            y_fwfnow(1) = local_sum( e1e2t(:,:) * ( emp(:,:) - rnf(:,:) + fwfisf_cav(:,:) + fwfisf_par(:,:) - snwice_fmass(:,:) ) )
+            CALL mpp_delay_sum( 'sbcfwb', 'fwb', y_fwfnow(:), z_fwfprv(:), kt == nitend - nn_fsbc + 1 )
+            z_fwfprv(1) = z_fwfprv(1) / area
+            zcoef = z_fwfprv(1) * rcp
+            emp(:,:) = emp(:,:) - z_fwfprv(1)        * tmask(:,:,1)
+            qns(:,:) = qns(:,:) + zcoef * sst_m(:,:) * tmask(:,:,1) ! account for change to the heat budget due to fw correction
+         ENDIF
+         !
+      CASE ( 4 )                             !==  global mean fwf set to zero (ISOMIP case) ==!
+         !
+         IF( MOD( kt-1, kn_fsbc ) == 0 ) THEN
             z_fwf = glob_sum( 'sbcfwb',  e1e2t(:,:) * ( emp(:,:) - rnf(:,:) + fwfisf_cav(:,:) + fwfisf_par(:,:) - snwice_fmass(:,:) ) )
             z_fwf = z_fwf / area
             zcoef = z_fwf * rcp
-            emp(:,:) = emp(:,:) - z_fwf              * tmask(:,:,1)
-            qns(:,:) = qns(:,:) + zcoef * sst_m(:,:) * tmask(:,:,1) ! account for change to the heat budget due to fw correction
-            sfx(:,:) = sfx(:,:) + z_fwf * sss_m(:,:) * tmask(:,:,1)
+            emp(:,:) = emp(:,:) - z_fwf            * tmask(:,:,1) ! (Eq. 34 AD2015)
+            qns(:,:) = qns(:,:) + zcoef * ( -1.9 ) * tmask(:,:,1) ! (Eq. 35 AD2015) ! could be sst_m if we don't want any bouyancy fluxes
+            sfx(:,:) = sfx(:,:) + z_fwf * ( 33.8 ) * tmask(:,:,1) ! (Eq. 36 AD2015) ! could be sss_m if we don't want any bouyancy fluxes
          ENDIF
          !